//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern bool   BetterFormula   = false;
extern int    MaMethod        = 3;  //0-3
extern int    MaPeriod        = 14;
extern int    BarWidth        = 0;
extern color  BarColorUp      = C'0,103,206';//DodgerBlue;
extern color  BarColorDn      = OrangeRed;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double UpH[];
double DnH[]; 
double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[];
double trend[];
int ArrSize = 110;

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
      IndicatorBuffers(7);
      SetIndexBuffer(0,UpH); SetIndexStyle(0,DRAW_ARROW,0,BarWidth,BarColorUp); SetIndexArrow(0,ArrSize);
      SetIndexBuffer(1,DnH); SetIndexStyle(1,DRAW_ARROW,0,BarWidth,BarColorDn); SetIndexArrow(1,ArrSize);
      SetIndexBuffer(2,Buffer1);
      SetIndexBuffer(3,Buffer2);
      SetIndexBuffer(4,Buffer3);
      SetIndexBuffer(5,Buffer4);
      SetIndexBuffer(6,trend);
      
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(timeFrame)+"  Hull Hama Histo");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpH[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      for (pos=limit; pos>=0; pos--)
      { 

         double maOpen  = iMA(NULL,0,MathFloor(MaPeriod/2),0,MaMethod,PRICE_OPEN ,pos)*2-iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_OPEN ,pos);
         double maClose = iMA(NULL,0,MathFloor(MaPeriod/2),0,MaMethod,PRICE_CLOSE,pos)*2-iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_CLOSE,pos);
         double maLow   = iMA(NULL,0,MathFloor(MaPeriod/2),0,MaMethod,PRICE_LOW  ,pos)*2-iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_LOW  ,pos);
         double maHigh  = iMA(NULL,0,MathFloor(MaPeriod/2),0,MaMethod,PRICE_HIGH ,pos)*2-iMA(NULL,0,MaPeriod,0,MaMethod,PRICE_HIGH ,pos);

         if (BetterFormula) {
               if (maHigh!=maLow)
                     double haClose = (maOpen+maClose)/2 + (((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
               else  haClose        = (maOpen+maClose)/2; }
         else        haClose        = (maOpen+maHigh+maLow+maClose)/4;
                     double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
                     double haHigh  = MathMax(maHigh, MathMax(haOpen,haClose));
                     double haLow   = MathMin(maOpen,  MathMin(haOpen,haClose));

         if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
         else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                               Buffer3[pos]=haOpen;
                               Buffer4[pos]=haClose;
         //
         //
         //
         //
         //
                              
         UpH[pos]   = EMPTY_VALUE;
         DnH[pos]   = EMPTY_VALUE;
         trend[pos] = trend[pos+1]; 
         if (Buffer3[pos]<Buffer4[pos]) trend[pos] =  1;
         if (Buffer3[pos]>Buffer4[pos]) trend[pos] = -1;
         if (trend[pos]== 1)            UpH[pos] = 0.5;
         if (trend[pos]==-1)            DnH[pos] = 0.5;
      }
      manageAlerts();
      return(0);
   }
   
         
      
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (pos=limit;pos>=0; pos--)
   {
      int y = iBarShift(NULL,timeFrame,Time[pos]);
         trend[pos]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,MaMethod,MaPeriod,6,y);
            UpH[pos] = EMPTY_VALUE;
            DnH[pos] = EMPTY_VALUE;
            if (trend[pos] == 1) UpH[pos] = 0.5;
            if (trend[pos] ==-1) DnH[pos] = 0.5;
   }
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Hull Hama ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Hull Hama "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


